package com.steerinfo.ems.emswaterrealtime.controller;

import com.steerinfo.ems.emswaterrealtime.model.EmsWaterRealtime;
import com.steerinfo.ems.emswaterrealtime.service.IEmsWaterRealtimeService;
import com.steerinfo.ems.trmcalpoint.service.ITRmCalpointService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * EmsWaterRealtime RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-24 07:52
 * 类描述
 * 修订历史：
 * 日期：2021-08-24
 * 作者：generator
 * 参考：
 * 描述：EmsWaterRealtime RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/emswaterrealtimes")
public class EmsWaterRealtimeController extends BaseRESTfulController {

    @Autowired
    IEmsWaterRealtimeService emsWaterRealtimeService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emswaterrealtime:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsWaterRealtime> list = emsWaterRealtimeService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emswaterrealtime:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsWaterRealtime> list = emsWaterRealtimeService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据EmsWaterRealtime对象创建")
    @ApiImplicitParam(name = "emsWaterRealtime", value = "详细实体emsWaterRealtime", required = true, dataType = "EmsWaterRealtime")
    //@RequiresPermissions("emswaterrealtime:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute EmsWaterRealtime model){
        EmsWaterRealtime emsWaterRealtime = emsWaterRealtimeService.add(model);
        return success(emsWaterRealtime);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short")
    //@RequiresPermissions("emswaterrealtime:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        EmsWaterRealtime emsWaterRealtime = emsWaterRealtimeService.getById(id);
        return success(emsWaterRealtime);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的emsWaterRealtime信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Short"),
        @ApiImplicitParam(name = "emsWaterRealtime", value = "详细实体emsWaterRealtime", required = true, dataType = "EmsWaterRealtime")
    })
    //@RequiresPermissions("emswaterrealtime:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody EmsWaterRealtime model){
        model.setId(id);
        EmsWaterRealtime emsWaterRealtime = emsWaterRealtimeService.modify(model);
        return success(emsWaterRealtime);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("emswaterrealtime:delete")
    @DeleteMapping(value = "/{id}")//Short
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  emsWaterRealtimeService.delete(ids);
    	}
      return success();
    }

    @Autowired
    ITRmCalpointService tRmCalpointService;


    @ApiOperation(value="生成", notes="生成水数据")
    //@RequiresPermissions("emswaterrealtime:delete")
    @GetMapping(value = "/water")//Short
    public int water(){
        emsWaterRealtimeService.getWaterListByArmMeter();
         emsWaterRealtimeService.dataGeneration();
        //emsWaterRealtimeService.getcalpoint();
        emsWaterRealtimeService.getWaterTenMinutes();

        tRmCalpointService.statHourData();
        return 1;
    }
}
